#!/usr/bin/env python
# -*- coding: utf-8 -*-

from optparse import OptionParser

import sys
sys.path.append('/usr/share/eole/controlevnc')
from cliscribe import Cliscribe, reactor
from connexions import Connexions

c=Connexions()


def stop_reactor(ret, nom, label):
    if ret == True:
        print('%s %s'%(label, nom))
    if reactor.running:
        reactor.stop()

def shutdown_sta(ip, reboot):
    """Appelle la fonction distante remote_shutdown du client Scribe
    reboot : 0=halt, 1=reboot, 2=logoff
    """
    nom = c.get_netbios_from_ip(ip)
    try :
        force = False
        if int(reboot) == 0:
            label = 'Extinction de'
            c.service_stop(ip)
        elif int(reboot) == 1:
            label = 'Redémarrage de'
            c.service_stop(ip)
        elif int(reboot) == 2:
            if not c.has_session(ip):
                print "Aucune session n'est ouverte sur %s (%s)" % (nom, ip)
                return
            label = 'Fermeture de session sur'
            force = True
        else:
            print "Option reboot inconnue %s" % str(reboot)
            sys.exit(1)

        d = Cliscribe(ip, disconnect=False).shutdown(reboot=reboot, force=force)
        d.addBoth(stop_reactor, nom, label)

        reactor.run()
    except Exception, err:
        try:
            msg = err.getErrorMessage()
        except:
            msg = "{0}".format(err)

        print "L'action sur %s a échoué, Erreur : %s" % (nom, msg)
        sys.exit(1)

def list_sta(verify):
    print c.get_station_up(verify)

def list_allsta():
    print c.get_stations()

def main():
    """
    boucle principale (gestion des options)
    """
    parser = OptionParser()
    parser.add_option("-s", "--shutdown", dest="shutdown",
            help=u"arrêter un machine (avec l'IP)")
    parser.add_option("-t", "--type", dest="stype", default="0",
            help=u"type du shutdown")
    parser.add_option("-l", "--list", action="store_true", dest="sliste",
            default=False, help=u"Liste les machines démarrées")
    parser.add_option("-v", "--verify", action="store_true", dest="verify",
            default=False, help=u"Vérifie que la machine est effectivement démarrée")
    parser.add_option("", "--list-all", action="store_true", dest="listall",
            default=False, help=u"Liste toute les machines du domaine")

    (options, args) = parser.parse_args()
    if options.shutdown:
        if options.sliste or options.listall:
            parser.print_help()
            sys.exit(1)
        shutdown_sta(options.shutdown, options.stype)
    elif options.listall:
        if options.sliste:
            parser.print_help()
            sys.exit(1)
        list_allsta()
    else:
        list_sta(options.verify)

if __name__ == '__main__':
    main()

